= Changelog archive =

This is an archive of older changelog entries. Most recent entries are maintained in readme.txt

= 2.8.5 =
- Support for individual virtual ads.txt files on multisite sites
- Few minor bug fixes, cosmetic changes and code improvements

= 2.8.4 =
- Few minor bug fixes, cosmetic changes and code improvements

= 2.8.3 =
- Added support to override dynamic blocks setting for each rotation
- Few minor bug fixes, cosmetic changes and code improvements

= 2.8.2 =
- Fix for ad blocking detection with AdBlock
- Added support for any post tag list check
- Few minor bug fixes, cosmetic changes and code improvements

= 2.8.1 =
- Updated depercated backend jQuery code
- Fix for reflected cross-site scripting (XSS)
- Few minor bug fixes, cosmetic changes and code improvements

= 2.8.0 =
- Replaced placeholder image generator service - changed to dummyimage.com
- Fix for false ad blocking detection when using external scripts
- Security fix for potential cross site scripting (Pro only)
- Added support to show rotation options in the list of blocks
- Added support for custom reports for clients (Pro only)
- Few minor bug fixes, cosmetic changes and code improvements

= 2.7.39 =
- Improved frontend code
- Fix for warning "Function _load_textdomain_just_in_time was called incorrectly"
- Updated Maxmind library (Pro only)
- Few minor bug fixes, cosmetic changes and code improvements

= 2.7.38 =
- Security fix for potential cross site scripting

= 2.7.37 =
- Removed deprecated setting Wait for jQuery
- Few minor bug fixes, cosmetic changes and code improvements

= 2.7.36 =
- Added support for WPML languages in the taxonomy list
- Added support to disable caching for LiteSpeed Cache and WP Fastest Cache plugins
- Added support to define the minimal block height for the close button to appear (Pro only)
- Few minor bug fixes, cosmetic changes and code improvements

= 2.7.35 =
- Added support for Simple History plugin
- Added support for external tracking for Google Tag Manager code (Pro only)
- Few minor bug fixes, cosmetic changes and code improvements

= 2.7.34 =
- Added support for ^ character to invert viewports in the VIEWPORT separator
- Added support for index parameter for counter shortcodes
- Changed text for content marker
- Few minor bug fixes, cosmetic changes and code improvements

= 2.7.33 =
- Changed widget class name
- Added option to define maximum number of list selection items
- Fix for Amazon external script causing false ad blocking detection
- Few minor bug fixes, cosmetic changes and code improvements

= 2.7.32 =
- Added experimental support for REST requests
- Added support for data shortcode for url parameters
- Added option for shortcodes to ignore category, tag, taxonomy and post ID lists
- Added support for background parallax ads (Pro only)
- Few minor bug fixes, cosmetic changes and code improvements

= 2.7.31 =
- Security fix for some data revealed via remote debugging data
- Added support to remove ad label when no code is inserted
- Few minor bug fixes, cosmetic changes and code improvements

= 2.7.30 =
- Improved debugging
- Few minor bug fixes, cosmetic changes and code improvements

= 2.7.29 =
- Added support for shortcode for reusable blocks by name
- Added support to force using get_queried_object function to get post id
- Few minor bug fixes, cosmetic changes and code improvements

= 2.7.28 =
- Added support for shortcode for reusable blocks
- Fix for PDF reports when site_url is different from home_url (Pro only)
- Few minor bug fixes, cosmetic changes and code improvements

= 2.7.27 =
- Fix for ad blocking detection external script trying to download a file

= 2.7.26 =
- Improved compatibility with PHP 8.2
- Security fix for deserialization
- Few minor bug fixes, cosmetic changes and code improvements

= 2.7.25 =
- Improved theme compatibility for sticky widgets with CSS mode
- Improved tracking for Google Analytics (Pro only)
- Added information bar when Wait for jQuery is enabled
- Few minor bug fixes, cosmetic changes and code improvements

= 2.7.24 =
- Added CSS Push mode for sticky widgets
- Added support for sticky ads (push mode) inside post/page content (Pro only)
- Added support for multiple activations of rotation groups
- Added support for %N@M format for filter counting
- Added support to prepend and append code to rotation option codes
- Added hook for click on the close button (Pro only)
- Improved front-end code
- Fix for client-side device detection on AMP pages
- Few minor bug fixes, cosmetic changes and code improvements

= 2.7.23 =
- Few minor bug fixes, cosmetic changes and code improvements

= 2.7.22 =
- Few minor bug fixes, cosmetic changes and code improvements

= 2.7.21 =
- Added support for Ad Inserter menu position
- Added support for random paragraph ranges
- Added support for default waiting time for user interaction (Pro only)
- Improved front-end code
- Few minor bug fixes, cosmetic changes and code improvements

= 2.7.20 =
- Fix for front-end translation

= 2.7.19 =
- Added constant to disable AdSense API
- Fix for rotation code editor
- Fix for advaced click tracker for banners (Pro only)
- Few minor bug fixes, cosmetic changes and code improvements

= 2.7.18 =
- Added support to hide ad label when unfilled AdSense block is hidden
- Simplified AdSense API authorization process
- Few minor bug fixes, cosmetic changes and code improvements

= 2.7.17 =
- Fixed bug for url parameters check
- Added support for reCaptcha v3 score check (Pro only)
- Few minor bug fixes, cosmetic changes and code improvements

= 2.7.16 =
- Added support for adb redirection page with url queries
- Added support for tcf-no-google shortcut
- Few minor bug fixes, cosmetic changes and code improvements

= 2.7.15 =
- Added filter hooks for ad labels
- Added support for constants
- Added support for rotation option index attribute
- Added shortcodes for block number and block name
- Few minor bug fixes, cosmetic changes and code improvements

= 2.7.14 =
- Added support for demo settings
- Added support for background transparency
- Added support for background for sticky ads (Pro only)
- Added support for statistics for check options (Pro only)
- Added support for individual rotation option statistics (Pro only)
- Few minor bug fixes, cosmetic changes and code improvements

= 2.7.13 =
- Few minor bug fixes, cosmetic changes and code improvements

= 2.7.12 =
- Security fix for settings page save url
- Added support to disable ad blocking detection for specific devices
- Few minor bug fixes, cosmetic changes and code improvements

= 2.7.11 =
- Security fix for sites using constants to prevent file editing or unfiltered HTML
- Added filters before the options are saved
- Added support for a shortcode for comma separated list of categories with quotes (for Google Ad Manager)
- Few minor bug fixes, cosmetic changes and code improvements

= 2.7.10 =
- Security fix for XSS (Reported by Krzysztof Zajac via WPScan)
- Added support to detect and replace blank AdSense blocks
- Added support to load and save plugins settings to a file (Pro only)
- Added support for parallax ads (Pro only)
- Few fixes

= 2.7.9 =
- Bug fix for timed rotations
- Bug fix for tr_TR translation
- Improved checks for cookies
- Improved compatibility with PHP 8.1
- Added separate list for cookies
- Few minor bug fixes, cosmetic changes and code improvements

= 2.7.8 =
- Bug fix for paragraph counting and clearance
- Bug fix for undefined constant error

= 2.7.7 =
- Few bug fixes

= 2.7.6 =
- Improved compatibility with PHP 8
- Added translation for tr_TR
- Added support to wait for an interaction before the block is loaded (Pro only)
- Added support to delay insertion of the block (Pro only)
- Few minor bug fixes, cosmetic changes and code improvements

= 2.7.5 =
- Few minor bug fixes, cosmetic changes and code improvements

= 2.7.4 =
- Updated Google API
- Improved labels for AdSense Auto ads
- Added external tracking support for WP username (Pro only)
- Few minor bug fixes, cosmetic changes and code improvements

= 2.7.3 =
- Improved ad blocking detection
- Improved compatibility with PHP 8
- Improved check for update server accessibility (Pro only)
- Few minor bug fixes, cosmetic changes and code improvements

= 2.7.2 =
- Added shortcuts for TCF v2 consent cookie checks
- Added support for adinserter shortcode to get post ID
- Improved ad blocking detection
- Changed internal IP to country database (Pro only)
- Few minor bug fixes, cosmetic changes and code improvements

= 2.7.1 =
- Added shortcuts for TCF v2 consent cookie checks
- Improved ad blocking detection
- Changed internal IP to country database (Pro only)
- Few minor bug fixes, cosmetic changes and code improvements

= 2.7.1 =
- Improved ad blocking detection
- Few minor bug fixes, cosmetic changes and code improvements

= 2.7.0 =
- Added support to list range of post IDs
- Added support for browser language in client lists
- Added support for client-side checks for filter hook ai_block_insertion_check
- Added support for remote plugin managenent (Pro only)
- Added support for scheduling check shortcode (Pro only)
- Added support for daily scheduling time (Pro onlyl)
- Added support for css attribute in check options (Pro only)
- Few minor bug fixes, cosmetic changes and code improvements

= 2.6.27 =
- Added support for scheduled rotation
- Few minor bug fixes, cosmetic changes and code improvements

= 2.6.26 =
- Few bug fixes (Pro only)

= 2.6.25 =
- Added support for block names in adinserter shortcode block attributes
- Added support for default custom field values
- Added support to list post ID range
- Improved ad blocking detection
- Reduced layout shift when using CHECK shortcodes
- Fix for expanded shortcodes in the rotate code generator
- Few minor bug fixes, cosmetic changes and code improvements

= 2.6.24 =
- Added support for consent attribute for code generator for AdSense and Amazon AMP ads
- Added support for random number shortcode
- Added support for && and !! operators in client-side client list checks
- Added scheduling time on blocks list (Pro only)
- Improved undismissible message when ad blocking is detected
- Few minor bug fixes, cosmetic changes and code improvements

= 2.6.23 =
- Reduced layout shift when using lists and client-side dynamic blocks
- Few minor bug fixes, cosmetic changes and code improvements

= 2.6.22 =
- Various security fixes
- Updated AdSense API authorization process
- Reduced layout shift when using client-side device detection
- Added option to block IP addresses for click fraud protection (Pro only)
- Few minor bug fixes, cosmetic changes and code improvements

= 2.6.21 =
- Improved compatibility with PHP 8
- Few minor bug fixes, cosmetic changes and code improvements

= 2.6.20 =
- Added support for alt text and lazy loading for banner code generator
- Few minor bug fixes, cosmetic changes and code improvements

= 2.6.19 =
- Improved code to reduce layout shift when using client-side device detection
- Added translation for es_ES
- Added translation for fr_FR
- Added translation for it_IT
- Improved compatibility with PHP 8
- Few minor bug fixes, cosmetic changes and code improvements

= 2.6.18 =
- Added support to change Dynamic blocks setting for adinserter PHP function call
- Few minor bug fixes, cosmetic changes and code improvements

= 2.6.17 =
- Fix for double client-side insertions when using geolocation (Pro only)

= 2.6.16 =
- Added support for ad blocking detection action every n pageviews
- Added support to individually disable pageview or click tracking (Pro only)
- Changed IAB TCF v2 cookie check name from euconsent-v2 to tcf-v2 (euconsent-v2 will still work)
- Fix for category check on category pages
- Fix for issues with Safari browser
- Few minor bug fixes, cosmetic changes and code improvements

= 2.6.15 =
- No ad blocking detection actions for crawlers and bots
- Fix for processing Ad Inserter shortcodes inside HTML tags
- Few minor bug fixes, cosmetic changes and code improvements

= 2.6.14 =
- Added support to insert [embed] shortcodes
- Few minor bug fixes, cosmetic changes and code improvements

= 2.6.13 =
- Few minor bug fixes

= 2.6.12 =
- Improved ad blocking detection
- Added options to delay client-side insertions at HTML element
- Added support to check for multiple cookie values (needed for IAB TCF 2.0)
- Added filter hooks for block processing
- Few minor bug fixes, cosmetic changes and code improvements

= 2.6.11 =
- Added support for IAB Transparency & Consent Framework 2.0
- Added support for taxonomy for primary category
- Added support for taxonomy for post meta data
- Added support to invert contain/do not contain text condition for paragraph counting
- Few minor bug fixes, cosmetic changes and code improvements

= 2.6.10 =
- Added user taxonomy items for logged-in and not logged-in users
- Added option to define tab setup delay (for the plugin settings page)
- Added option to insert unique ad rotation options when block is inserted more than once
- Added support for client-side device detection for AMP pages (for method Show)
- Added support for code generator for Amazon AMP ads
- Added support for custom tracking events (Pro only)
- Few minor bug fixes, cosmetic changes and code improvements

= 2.6.9 =
- Added option for paragraph counting to search only tag attributes for text
- Added option to embed block Javascript code (to be loaded with Ajax calls)
- Added support to prevent duplicate insertions when the_content filter is called more than once (experimental)
- Added support for the client list to check for partial user agent strings
- Added support for check of cookie object properties
- Improved ad blocking detection
- Viewports no longer need to be in descending width order
- Added option to protect inserted block content (Pro only)
- Added support for adb scripts path filter hook (Pro only)
- Added support to export statistics data to CSV file (Pro only)
- Few minor bug fixes, cosmetic changes and code improvements

= 2.6.8 =
- Added support to disable PHP processing by PHP constant
- Added support to repeat COUNT options
- Added support for offset for %n paragraph number (%n@o)
- Added support for options to skip insertion for first and last paragraphs
- Added support for hook filter 'ai_block_insertion_check'
- Added support for background ads (Pro only)
- Few minor bug fixes, cosmetic changes and code improvements

= 2.6.7 =
- Added support for various shortcodes for post categories
- Added support for various shortcodes for post tags
- Added support for user action on click (Pro only)
- Added support for manual loading (Pro only)
- Few minor bug fixes, cosmetic changes and code improvements

= 2.6.6 =
- Fix for exceptions list not showing all exceptions
- Improved ad blocking detection
- Fix for close button in preview window (Pro only)
- Few minor bug fixes, cosmetic changes and code improvements

= 2.6.5 =
- Added support for url data shortcode
- Added warning if not all exceptions were cleared
- Added support for MaxMind country only database (Pro only)
- Added support for ip to country lookup filter hook (Pro only)
- Fix for country groups in CHECK separators (Pro only)
- Few minor bug fixes, cosmetic changes and code improvements

= 2.6.4 =
- Fix for use of undefined constant warning (Pro only)

= 2.6.3 =
- Added support for shortcodes to disable block insertion
- Added support for child taxonomy list items
- Added random parameter to Ajax requests for geolocation (Pro only)
- Added options to define external tracking event category, action and label (Pro only)
- Number of custom hooks increased to 20
- Fix to prevent insertion into head section when using Rank Math plugin
- Few minor bug fixes, cosmetic changes and code improvements

= 2.6.2 =
- Added support to disable caching of block PHP code
- Added support to pause blocks on the blocks list
- Added support for no url parameters list item
- Added support for client-side scheduling (Pro only)
- Added support for server-side scheduling using W3TC (Pro only)
- Added support for multisite:site-id taxonomy list item (Pro only)
- Updated MaxMind GeoLite2 database download using license key (Pro only)
- Changed settings format in the database to prevent export/import issues with MySQL/PhpMyAdmin
- Fix for [ADINSERTER counter] shortcode not expanding inside HTML tags
- Few minor bug fixes, cosmetic changes and code improvements

= 2.6.1 =
- Fix for errors on the settings page
- Fix for non English characters in ads
- Fix for sticky widgets
- Few minor bug fixes

= 2.6.0 =
- Added support for VIEWPORT separator
- Added support for viewport check in CHECK separators (Pro only)
- Added support to show processing log on front-end
- Added support to show link to the Ad Inserter Pro settings page on multisite Sites page (Pro only)
- Added support to detect and prevent document.write after DOM is ready
- Added support for scheduling hours (Pro only)
- Added support for scheduling days in week (Pro only)
- Added support for W3TC insertion debugging info
- Improved Javascript code for client-side functions
- Improved ad blocking detection
- Default value for Wait for jQuery set to Enabled
- Few minor bug fixes, cosmetic changes and code improvements

= 2.5.10 =
- Optimized Javascript code to allow advanced optimizations
- Added support to wait for jQuery so it can be deferred
- Added support for children categories in lists
- Added support to load settings page in safe mode
- Added warning notice if PHP version is below 5.6
- Improved user interface for lists
- Modified Javascript code that was wrongly replaced by CDN url
- Fix for updates server access warning message (Pro only)
- Few minor bug fixes, cosmetic changes and code improvements

= 2.5.9 =
- Added support for block name class
- Added support for code generator for AdSense sticky AMP ads
- Fix for paragraph clearance issues
- Few minor bug fixes, cosmetic changes and code improvements

= 2.5.8 =
- Added support to call function adinserter () with block name
- Added support to insert header code with HEAD separator only once
- Additional info for errors when saving settings
- Improved support for insertion between posts on AMP pages
- Implemented compatibility with other plugins using phpQuery library
- Added support for shortcode to disable tracking on specific pages (Pro only)
- Few minor bug fixes, cosmetic changes and code improvements

= 2.5.7 =
- Fix for error when saving settings

= 2.5.6 =
- Added support for PenCi Soledad AMP plugin
- Fix for php processing on multisite installations
- Fix for client-side referrer check
- Fix for header and footer code on AMP pages using AMP plugin
- Few minor bug fixes, cosmetic changes and code improvements

= 2.5.5 =
- Added support for client list (black/whitelist operating systems, browsers, device names)
- Fix for replaced tags with default value {name:default-value}
- Few minor bug fixes, cosmetic changes and code improvements

= 2.5.4 =
- Minor bug fix regarding update checks (Pro only)

= 2.5.3 =
- Added support for warning when Ad Inserter is disabled by AMPforWP Plugin Manager
- Added support for block shortcode attributes
- Added support for post ID list to include all posts or static pages
- Added option for maximum number of paragraphs
- Added support to check for update server accessibility (Pro only)
- Added ids to ad blocking popup message and overlay elements
- Few minor bug fixes, cosmetic changes and code improvements

= 2.5.2 =
- Added options to define paragraph counting inside container elements
- Added support to pin block list (Pro only)
- Few minor bug fixes, cosmetic changes and code improvements

= 2.5.1 =
- Few minor bug fixes (Pro only)

= 2.5.0 =
- Improved user interface
- Simplified user interface for individual post/page exceptions
- Added support for virtual ads.txt file
- Added support for frequency capping (Pro only)
- Added support for click fraud detection (Pro only)
- Changed url prefix for public reports to avoid possible url collisions (Pro only)
- Fix for shortcode processing when blocks were used before init hook
- Many minor bug fixes, cosmetic changes and code improvements

= 2.4.23 =
- Added support to define custom fields with shortocdes
- Added support to delay showing ads for specified number of pageviews (Pro only)
- Added support to remember closed ad for specified time period (Pro only)
- Added support to automatically close ad after specified time period (Pro only)
- Fix for false positive ad blocking detection (Pro only)
- Few minor bug fixes, cosmetic changes and code improvements

= 2.4.22 =
- Fix for remote code execution vulnerability - credit to Wordfence

= 2.4.21 =
- Fix for possible error Class not found (Pro only)

= 2.4.20 =
- Fix for path traversal vulnerability - credit to Wilfried Becard of Synacktiv (https://synacktiv.com)
- Fix for block rearrangement issues
- Few minor bug fixes, cosmetic changes and code improvements

= 2.4.19 =
- Added support for taxonomy for Yoast primary category
- Layout changes to accomodate longer translated texts
- Fix for escape character not saved in header, footer and ad blocking message code
- Few minor bug fixes, cosmetic changes and code improvements

= 2.4.18 =
- Added support for full width responsive AdSense code option
- Few minor bug fixes, cosmetic changes and code improvements

= 2.4.17 =
- Few minor bug fixes, cosmetic changes and code improvements

= 2.4.16 =
- Fix for compatibility with AMP for WP - Accelerated Mobile Pages for WordPress
- Few minor bug fixes

= 2.4.15 =
- Fix for improved compatibility with other plugins
- Few minor bug fixes and cosmetic changes

= 2.4.14 =
- Fix for ROTATE shortcodes with option name identical to block name
- Fix for possible conflict with output buffering in other plugins
- Few minor bug fixes, cosmetic changes and code improvements

= 2.4.13 =
- Added shortcode to disable ad blocking detection code
- Added options to disable ad blocking actions for administrators or logged in users
- Added option to change PDF report footer (Pro only)
- Added support for public ad impression and click reports (Pro only)
- Few minor bug fixes, cosmetic changes and code improvements

= 2.4.12 =
- Added ads.txt editor
- Added option to prevent disabling caching for logged in administrators
- Improved compatibility with PHP 7.2
- Few minor bug fixes, cosmetic changes and code improvements

= 2.4.11 =
- Fix for saving code with slashes
- Fix for rotation editor code import
- Few minor bug fixes, cosmetic changes and code improvements

= 2.4.10 =
- Added support for counter shortcodes
- Added support for code separator selection for code preview
- Added support for group rotations
- Added support for CHECK separator (Pro only)
- Added links to test pages for check for available positions
- Few minor bug fixes, cosmetic changes and code improvements

= 2.4.9 =
- Added support for HEAD separator
- Added support for DoubleClick for Publishers (DFP) ads
- Added support to generate statistics reports in PDF format (Pro only)
- Fix for ad label when using AMP separator
- Fix for AdSense code fixed by viewport
- Fix for error when checking for available positions
- Few minor bug fixes, cosmetic changes and code improvements

= 2.4.8 =
- Added support for automatic insertion before/after image
- Added support for theme checker for available positions for automatic insertion

= 2.4.7 =
- Fix for lazy loading in Ajax calls (Pro only)
- Fix for country list editor (Pro only)
- Few minor bug fixes, cosmetic changes and code improvements

= 2.4.6 =
- Improved ad blocking detection (detects Firefox content blocking)
- Added support for wildcards for referrers (domains)
- Added debugging notice when JavaScript errors are detected
- Added support to load blocks in iframes (Pro only)
- Added geolocation support for country subdivisions and cities (Pro only)
- Added option to hide license key on client websites (Pro only)
- Few minor bug fixes, cosmetic changes and code improvements

= 2.4.5 =
- Added support for AMP WP - Google AMP For WordPress
- Added support to individually disable insertions for debugging purposes
- Improved HTML element selection tool
- Fix for Call to undefined function wp_get_current_user()
- Few minor bug fixes, cosmetic changes and code improvements

= 2.4.4 =
- Fix for Fatal error: Call to undefined function mb_strtoupper()

= 2.4.3 =
- Added support for insertion before/after every N paragraphs (%N)
- Added support for i18n
- Fix for insertion on admin pages
- Fix for client-side cookie check
- Fix for loaded styles from other plugins/themes on the settings page
- Fix for client-side insertion near HTML elements using :eq selector
- Fix for deactivation feedback form not closing
- Few minor bug fixes, cosmetic changes and code improvements

= 2.4.2 =
- Added support for visual HTML element selection
- Fix for client-side insertion inside HTML elements
- Few minor bug fixes, cosmetic changes and code improvements

= 2.4.1 =
- Added option to insert into HTML element (prepend, append, replace content)
- Added option to remove HTML element
- Added option to not show deactivation feedback form
- Added support for negative relative positions for paragraph counting
- Few minor bug fixes, cosmetic changes and code improvements

= 2.4.0 =
- Improved code for client-side insertion
- Added support for usage tracking
- Fix for compatibility with older PHP versions (below 5.4)
- Few minor bug fixes, cosmetic changes and code improvements

= 2.3.21 =
- Added option to force showing admin toolbar when viewing site
- Added additional debugging info for blocks in Ajax requests
- Fix for viewport visibility detection
- Fix for rotation with non-ASCII characters
- Few minor bug fixes, cosmetic changes and code improvements

= 2.3.20 =
- Improved loading of settings
- Fix for content processing in some ajax calls
- Few minor bug fixes, cosmetic changes and code improvements

= 2.3.19 =
- Improved code for client-side insertion
- Fix for rotation with shortcodes
- Few minor bug fixes, cosmetic changes and code improvements

= 2.3.18 =
- Added support to schedule insertion for N days after publishing
- Added support to schedule insertion only for posts published inside/outside time period (Pro only)
- Added support to prevent activation of free Ad Inserter while Pro is active
- Added url parameter to show block code
- Improved Header/Footer code debugging
- Few minor bug fixes, cosmetic changes and code improvements

= 2.3.17 =
- Added shortcode for ad blocking detection action
- Few minor bug fixes, cosmetic changes and code improvements

= 2.3.16 =
- Added option to insert block only when WP loop is currently active
- Added support for Better AMP plugin
- Code generator for placeholders on https sites now generates https urls
- Optimized loading of plugin settings
- Few minor bug fixes, cosmetic changes and code improvements

= 2.3.15 =
- Fix for insertion on AMP pages

= 2.3.14 =
- Simplified AdSense integration
- Added setting to define maximum number of blocks (ads) per page
- Optimized the_content filter processing
- Added setting for lazy loading offset (Pro only)
- Fix for url parameter list when using client-side dynamic blocks
- Few minor bug fixes, cosmetic changes and code improvements

= 2.3.13 =
- Added support for lazy loading (Pro only)
- Fix for unwanted insertions with some paragraph settings
- Few minor bug fixes, cosmetic changes and code improvements

= 2.3.12 =
- Fix for urlencode error
- Few other minor bug fixes

= 2.3.11 =
- Added support for W3TC/client-side check for cookies (in url parameter list) to support showing ads based on visitor's cookie consent
- Added support for W3TC/client-side check for referers
- Improved paragraph processing
- Few minor bug fixes, cosmetic changes and code improvements

= 2.3.10 =
- Added support for timed rotation
- Added support for client-side insertion of dynamic blocks
- Improved word count function
- Few minor bug fixes, cosmetic changes and code improvements

= 2.3.9 =
- Added option to easily disable insertion of individual code block
- Changes for compatibility with PHP 7.2
- Added non-interaction parameter to external tracking (Pro only)
- Few minor bug fixes, cosmetic changes and code improvements

= 2.3.8 =
- Added support for rotation option shares
- Added support for sticky ad settings and animations (Pro only)
- Few minor bug fixes, cosmetic changes and code improvements

= 2.3.7 =
- Added support for ad labels
- Blocked search indexing while debugging
- Close button setting moved to tab Display (Pro only)
- Few minor bug fixes, cosmetic changes and code improvements

= 2.3.6 =
- Added widget for debugging tools
- Fix for AdSense ad overlays not displayed with some themes
- Few minor bug fixes, cosmetic changes and code improvements

= 2.3.5 =
- Added display of header and footer code in Label blocks debugging function
- Added AdSense ad overlays in Label blocks debugging function (experimental)
- Fixed bug for removed square brackets in HTML element selectors
- Fixed preview of AdSense ad units
- Few minor bug fixes

= 2.3.4 =
- Added support for author:author-username items in taxonomy list
- Fixed errors when downgrading from Pro
- Few minor bug fixes

= 2.3.3 =
- Added list editors
- Added Label blocks debugging function for AdSense Auto ads

= 2.3.2 =
- Added AdSense code generator for ad sizes using CSS media queries
- Fix for slow updates caused by changed user agent (Pro only, credits Olivier Langlois)
- Fix for client-side insertion of non-English characters before/after HTML element

= 2.3.1 =
- Added support for server-side insertion before/after any HTML element
- Few minor bug fixes

= 2.3.0 =
- Added support for client-side insertion before/after any HTML element
- Inplemented AdSense integration
- Added option to define close button position
- Fix for code generator import and code preview error with non ASCII characters
- Fix for post/page exceptions and page types not processed in the header
- Fix for close button in preview window
- Fix for errors when rearranging blocks
- Fix for errors when importing code
- Few minor bug fixes, cosmetic changes and code improvements

= 2.2.16 =
- Fix for error when saving settings on multisite installation

= 2.2.15 =
- Fix for responsive AMP ads using center alignment

= 2.2.14 =
- Added code generator for placeholders
- Added option to disable caching (works with WP Super Cache, W3 Total Cache and WP Rocket)
- Added options to configure classes for wrapping div
- Added support for external tracking via Google Analytics and Piwik (Pro only)
- Added support for MaxMind geolocation databases (Pro only)
- Added option for close button on sticky ads (Pro only)
- Fix for no paragraph counting inside nested elements
- Few minor bug fixes, cosmetic changes and code improvements

= 2.2.13 =
- Added option to disable inline alignment styles for code blocks (using alignment classes)
- Fix for custom CSS codes with single quotation marks

= 2.2.12 =
- Fix for code block styles when block class name was not set

= 2.2.11 =
- Code block styles moved to classes
- Code block list moved to the sidebar
- Added preview buttons in code block list
- Fix for ad blocking detection when using https (Pro only)
- Few minor bug fixes, cosmetic changes and code improvements

= 2.2.10 =
- Fix for rotation editor code import/export
- Fix for errors when using old |rotate| separator
- Few minor bug fixes, cosmetic changes and code improvements

= 2.2.9 =
- Output buffering is now disabled by default (for position Above header you need to enable it)
- Fix for min. paragraph number not processed

= 2.2.8 =
- Added position for automatic insertion Above header (after `<body>` tag)
- Added rotation code editor
- Added support to name rotation options
- Added code generator for banners
- Added code generator for AdSense
- Added support to rearrange code blocks
- Added support to copy any block settings
- Added support for clipboard to copy/paste block settings
- Added option to select ad blocking detection mode (Pro only)
- Delayed insertion on posts now available for all insertion positions
- Few minor bug fixes, cosmetic changes and code improvements

= 2.2.7 =
- Fix for duplicate amp-custom tag on AMP pages

= 2.2.6 =
- Fix for posts filter counter not counting
- Added list with short overview of all code blocks
- Added support for word count on blog pages
- Added support for client code preview (no need to save it for preview)
- Improved compatibility on AMP pages
- Few minor bug fixes, cosmetic changes and code improvements

= 2.2.5 =
- Fix for issue with Ajax requests

= 2.2.4 =
- Added support to insert raw HTTP response header lines
- Added support to check for individual exceptions for shortcodes
- Added support to trigger ad blocking detection action only on individual pages
- Added support for automatic insertion position Footer
- Added support for custom hooks
- Url parameter list now checks url parameters ($_GET) and cookies ($_COOKIE)
- Fix for |count| separator not processed

= 2.2.3 =
- Added support to insert custom fields via shortcode [adinserter custom-field='CUSTOM_FIELD_NAME']
- Added support for user:USERNAME and user-role:USER_ROLE taxonomy list items
- Added support for post-type:POST_TYPE taxonomy list items
- Added support for JavaScript based sticky widgets
- Added support for ad blocking statistics (Pro only)
- Added support for WP AMP and WP AMP Ninja plugins
- Post/Page Word Count moved to Misc section (now works also on widgets)
- Few minor bug fixes, cosmetic changes and code improvements

= 2.2.2 =
- Fix for mobile admin layout
- Few other minor bug fixes

= 2.2.1 =
- Fix for header/footer scripts on AMP pages

= 2.2.0 =
- Added support for ad blocking detection (experimental)
- Added support for [ADINSERTER AMP] shortcode to separate code for AMP pages
- Added support for [ADINSERTER ROTATE] and [ADINSERTER COUNT] shortcodes
- Added syntax highlighting for shortcodes and separators
- Added option to define minimum number of words in paragraphs above
- Added support for %N filter item to filter every N-th insertion
- Added filter support when inserting for all paragraphs
- Added style `clear: both;` to Default, Left, Right and Center alignments
- Bug fix for errors when loading tracking charts (Pro only)
- Many minor bug fixes, cosmetic changes and code improvements

= 2.1.14 =
- Fix for error when using older PHP versions (prior to 5.5)

= 2.1.13 =
- Fix for Fatal error: Can't use method return value in write context

= 2.1.12 =
- Added option to define tags inside which paragraphs are not counted
- Added max insertions check when inserting for all paragraphs
- Added support for inverted filter
- Increased nonce lifespan to 48 hours when using tracking (Pro only)
- Fixed wrong urls in debug menu when behind proxy
- Few other bug fixes, cosmetic changes and code improvements

= 2.1.11 =
- Improved support for sticky widgets (works with most themes)
- Added support for ad counting (|count| separator)
- Added support to black/white-list arbitrary taxonomies (taxonomy, term or taxonomy:term)
- Added support for automatic insertion before, between and after comments
- Added processing of shortcodes in the header and footer code
- Debugging function Show positions shows also page type
- Fixed page type detection when Post page was set to static page and it was not homepage
- Few minor bug fixes, cosmetic changes and code improvements

= 2.1.10 =
- Fix for shifted sidebars in some themes

= 2.1.9 =
- Added support for sticky widgets
- Added support to insert code after images (Automatic Insertion: After Paragraph, Paragraphs with tags: img)
- Impression and click tracking (beta, Pro only)
- Few minor bug fixes, cosmetic changes and code improvements

= 2.1.8 =
- Fixed error when using server-side device detection

= 2.1.7 =
- Fixed error when using PHP 5.4 or earlier

= 2.1.6 =
- Added support for insertion before/after multiple paragraphs
- Added initial support for impression and click tracking (Pro only)
- Few bug fixes and cosmetic changes

= 2.1.5 =
- Added support to avoid insertion inside `<figure>` and `<li>` elements (image captions, lists)
- Added support for exceptions for custom post types
- Few minor bug fixes and code improvements

= 2.1.4 =
- Paragraph counting restored to standard functions
- Added option to select paragraph counting functions with multibyte support (unicode characters)
- Fixed bug for wrong paragraph counting in posts with blockquote sections in some cases
- Fixed bug for wrong measuring of plugin processing time in some cases
- Fixed bug for "Empty delimiter" warning

= 2.1.3 =
- Added support for counting paragraphs with multibyte (unicode) characters
- Fixed bug for class name not saved
- Few minor bug fixes and cosmetic changes

= 2.1.2 =
- Fixed bug for disabled settings page on multisite blogs

= 2.1.1 =
- Changes for compatibility with PHP 7.1
- Automatic rename of old pro plugin slug (Pro only)
- Added support for additional Pro features (Pro only)
- Few bug fixes and cosmetic changes

= 2.1.0 =
- Added support to insert ads in Ajax requests (e.g. in infinite scroll)
- Added support to not include block classes when class name is empty
- Added sticky positions (Pro only)
- Bug fix for minimum user role not taken into account for exceptions list
- Bug fix for IP database update cron event (Pro only)

